Index: /branches/rsr.v5.1.dev/web/app/mods/e_backend.php
===================================================================
--- /branches/rsr.v5.1.dev/web/app/mods/e_backend.php	(revision 1)
+++ /branches/rsr.v5.1.dev/web/app/mods/e_backend.php	(revision 1)
@@ -0,0 +1,212 @@
+<?php
+
+  # -----------------------------------------------------------------------------------
+  #                                                                   fonction generale
+  #
+
+  function e_backend($env)
+  { if($_GET[$env->param("action")])
+    { $function = "a_".$_GET[$env->param("action")];
+      if(function_exists($function))
+      { $function($env);
+      }
+    }
+  }
+
+  # -----------------------------------------------------------------------------------
+  #                                                                             actions
+  #
+
+  # ----------------------------------------
+  # playlists audio generales
+
+  function a_last_downloads($env)
+  { if(($downloads = $env->data->pl_last_downloads(10)) !== false)
+    { if($_GET[$env->param("format")] == "m3u")
+      { echo get_m3u($downloads);
+        exit;
+      }
+      elseif($_GET[$env->param("format")] == "atom")
+      { $env->out["atom"] = get_downloads_atom
+        ( "last_downloads",
+          $env->config("site_name"),
+          "les 10 derniers morceaux",
+          "http://".$_SERVER["HTTP_HOST"].$env->url(array("e" => "last_downloads", "format" => "atom"), "backend.php"),
+          "http://".$_SERVER["HTTP_HOST"].$env->url(array("e" => "playlist", "action" => "last_downloads"), "index.php"),
+          $downloads
+        );
+      }
+    }
+    else echo "Erreur lors de l'acc&egrave;s aux downloads";
+  }
+
+  function a_rand_downloads($env)
+  { header('Content-type: application/atom+xml; charset=UTF-8');
+    if(($downloads = $env->data->pl_rand_downloads(10)) !== false)
+    { if($_GET[$env->param("format")] == "m3u")
+      { echo get_m3u($downloads);
+        exit;
+      }
+      elseif($_GET[$env->param("format")] == "atom")
+      { $env->out["atom"] = get_downloads_atom
+        ( "rand_downloads",
+          $env->config("site_name"),
+          "10 morceaux au hasard",
+          "http://".$_SERVER["HTTP_HOST"].$env->url(array("e" => "rand_downloads", "format" => "atom"), "backend.php"),
+          "http://".$_SERVER["HTTP_HOST"].$env->url(array("e" => "playlist", "action" => "rand_downloads"), "index.php"),
+          $downloads
+        );
+      }
+    }
+    else echo "Erreur lors de l'acc&egrave;s aux downloads";
+  }
+
+  # ----------------------------------------
+  # playlists artistes
+
+  function a_artiste_downloads($env)
+  { if($_GET[$env->param("format")] == "m3u")
+    { if
+      ( ( $downloads = $env->data->pl_artiste_downloads
+          ( $_GET[$env->param("artiste")],
+            isset($_GET[$env->param("album")]) ? $_GET[$env->param("album")] : null
+          )
+        ) !== false
+      )
+      { echo get_m3u($downloads);
+        exit;
+      }
+      else echo "Erreur lors de l'acc&egrave;s aux downloads";
+    }
+  }
+
+  function a_artiste_mp3($env)
+  { if($_GET[$env->param("format")] == "playlist_xml")
+    { if
+      ( ( $env->out["downloads"] = $env->data->artiste_downloads
+          ( $_GET[$env->param("artiste")],
+            true,
+            $_GET[$env->param("album")] ? $_GET[$env->param("album")] : null
+          )
+        ) !== false
+      )
+      { header("Content-Type: application/xml");
+      }
+      else echo "Erreur lors de l'acc&egrave;s aux downloads";
+    }
+  }
+
+  # ----------------------------------------
+  # news generales
+
+  function a_last_news($env)
+  { if(($news = $env->data->contenus(array("root", "news"), 0, 10, " AND public=1 AND date_publication <= NOW()")) !== false)
+    { $news = $news["list"];
+      foreach($news as $id_news => $_news) $news[$id_news]["url"] =
+      "http://".$_SERVER["HTTP_HOST"].$env->url(array("e" => "content", "id" => $id_news), "index.php");
+      if($_GET[$env->param("format")] == "atom")
+      { $env->out["atom"] = get_content_atom
+        ( "last_news",
+          $env->config("site_name"),
+          "les 10 dernieres news",
+          "http://".$_SERVER["HTTP_HOST"].$env->url(array("e" => "last_news", "format" => "atom"), "backend.php"),
+          "http://".$_SERVER["HTTP_HOST"].$env->url(array("e" => "accueil"), "index.php"),
+          $news
+        );
+      }
+    }
+    else echo "Erreur lors de l'acc&egrave;s aux downloads";
+  }
+
+  # ----------------------------------------
+  # news artistes
+
+  function a_last_artiste_news($env)
+  { if(($news = $env->data->contenus(array("root", "artistes", "news", $_GET[$env->param("artiste")]), 0, 10, " AND public=1 AND date_publication <= NOW()")) !== false)
+    { $news = $news["list"];
+      foreach($news as $id_news => $_news) $news[$id_news]["url"] =
+      "http://".$_SERVER["HTTP_HOST"].$env->url(array("e" => "content", "id" => $id_news), "index.php");
+      if($_GET[$env->param("format")] == "atom")
+      { $env->out["atom"] = get_content_atom
+        ( "last_news",
+          $env->config("site_name"),
+          "les 10 dernieres news",
+          "http://".$_SERVER["HTTP_HOST"].$env->url(array("e" => "last_news", "format" => "atom"), "backend.php"),
+          "http://".$_SERVER["HTTP_HOST"].$env->url(array("e" => "accueil"), "index.php"),
+          $news
+        );
+      }
+    }
+    else echo "Erreur lors de l'acc&egrave;s aux downloads";
+  }
+
+  # -----------------------------------------------------------------------------------
+  #                                                                               utils
+  #
+
+  function get_m3u($downloads, $debug = false)
+  { $playlist =
+     "#EXTM3U\n";
+    if($downloads) foreach($downloads as $id => $download)
+    { $playlist .=
+       "#EXTINF:-1,".$download["titre"]."\n"
+      .$download["url"]."\n";
+    }
+    if(!$debug)
+    { header("Content-type: audio/x-mpegurl");
+      header('Content-Disposition: inline; filename=playlist.m3u');
+      header("Content-Length: ".strlen($playlist));
+    }
+    return $playlist;
+  }
+
+  function get_downloads_atom($id, $author, $title, $self, $alternate, $downloads)
+  { $atom = array
+    ( "id" => "tag:".$_SERVER["HTTP_HOST"].",".date("Y-m-d").":".$id,
+      "author_name" => $author,
+      "title" => $title,
+      "updated" => date("Y-m-d")."T".date("H:i:s")."Z",
+      "link" => array("self" => str_replace("&", "&amp;", $self), "alternate" => str_replace("&", "&amp;", $alternate)),
+      "entries" => array()
+    );
+    foreach($downloads as $id_download => $download)
+    { $atom["entries"][$id_download] = array
+      (  "id" => "tag:".$_SERVER["HTTP_HOST"].","
+        .$download["year_updated"]."-".$download["month_updated"]."-".$download["day_updated"]
+        .":download/".$id_download,
+        "title" => $download["auteur"]." - ".$download["titre"],
+        "updated" => $download["year_updated"]."-".$download["month_updated"]."-".$download["day_updated"]."T00:00:00Z",
+        "author_name" => $download["auteur"],
+        "enclosure" => str_replace("&", "&amp;", $download["url"]),
+        "content_type" => $download["content_type"],
+        "link" => array("alternate" => str_replace("&", "&amp;", $download["url"]))
+      );
+    }
+    return $atom;
+  }
+
+  function get_content_atom($id, $author, $title, $self, $alternate, $contents)
+  { $atom = array
+    ( "id" => "tag:".$_SERVER["HTTP_HOST"].",".date("Y-m-d").":".$id,
+      "author_name" => $author,
+      "title" => $title,
+      "updated" => date("Y-m-d")."T".date("H:i:s")."Z",
+      "link" => array("self" => str_replace("&", "&amp;", $self), "alternate" => str_replace("&", "&amp;", $alternate)),
+      "entries" => array()
+    );
+    foreach($contents as $id_content => $content)
+    { $atom["entries"][$id_content] = array
+      (  "id" => "tag:".$_SERVER["HTTP_HOST"].","
+        .$download["year_updated"]."-".$download["month_updated"]."-".$download["day_updated"]
+        .":content/".$id_content,
+        "title" => $content["titre"],
+        "updated" => $content["date_modification"]."T00:00:00Z",
+        "author_name" => $content["auteur"],
+        "summary" => str_replace("&", "&amp;", $content["contenu"]),
+        "link" => array("alternate" => str_replace("&", "&amp;", $content["url"]))
+      );
+    }
+    return $atom;
+  }
+
+?>
Index: /branches/rsr.v5.1.dev/web/app/mods/e_carte.php
===================================================================
--- /branches/rsr.v5.1.dev/web/app/mods/e_carte.php	(revision 1)
+++ /branches/rsr.v5.1.dev/web/app/mods/e_carte.php	(revision 1)
@@ -0,0 +1,15 @@
+<?php
+
+  function e_carte($env)
+  { if($env->pun_user["is_guest"]) _login($env);
+    else
+    { $env->out["VIEW_MAP"] = $env->data->view_map_ok($env);
+      $env->out["EDIT_MAP"] = $env->data->edit_map_ok($env);
+      $env->out["EDIT_ON"] = isset($_GET[$env->param("edit")]);
+      if(($env->out["emplacement_types"] = $env->data->map_emplacement_types()) === false)
+      { $env->erreur = "Impossible de lire la liste des types d'emplacement"; 
+      }
+    }
+  }
+
+?>
Index: /branches/rsr.v5.1.dev/web/app/mods/e_contact.php
===================================================================
--- /branches/rsr.v5.1.dev/web/app/mods/e_contact.php	(revision 1)
+++ /branches/rsr.v5.1.dev/web/app/mods/e_contact.php	(revision 1)
@@ -0,0 +1,36 @@
+<?php
+
+  function e_contact($env)
+  { require $env->path("app")."plugins/ptitcaptcha.php";
+    if($_POST)
+    { if($_POST["from"] && $env->data->is_email($_POST["from"]))
+      { if(PtitCaptchaHelper::checkCaptcha())
+        { if
+          ( @mail
+            ( $env->config("email_contact"),
+              "Message depuis ".$env->config("site_name"),
+               "Depuis le formulaire de contact du site\n\n"
+              ."email de l'expediteur : ".$_POST["from"]."\n"
+              ."sujet : ".$_POST["sujet"]."\n"
+              ."message : \n"
+              ."------------------------------------\n"
+              .$_POST["message"],
+              "From: ".$_POST["from"]."\r\n"
+            )
+          )
+          { _redirect
+            ( $env,
+              $env->url(array("e" => "contact", "action" => "ok")),
+              "Votre message a &eacute;t&eacute; envoy&eacute;",
+              2
+            );
+          }
+          else $env->erreur = "Une erreur est survenue. Impossible d'envoyer le message.";
+        }
+        else $env->message = "L'anti-spam ne correspond pas";
+      }
+      else $env->message = "Merci de pr&eacute;ciser votre email";
+    }
+  }
+
+?>
Index: /branches/rsr.v5.1.dev/web/app/mods/e_content.php
===================================================================
--- /branches/rsr.v5.1.dev/web/app/mods/e_content.php	(revision 1)
+++ /branches/rsr.v5.1.dev/web/app/mods/e_content.php	(revision 1)
@@ -0,0 +1,10 @@
+<?php
+
+  function e_content($env)
+  { if(($env->out["content"] = $env->data->contenu($_GET[$env->param("id")])) !== false)
+    {
+    }
+    else $env->erreur .= "<br>Impossible de lire le contenu";
+  }
+
+?>
Index: /branches/rsr.v5.1.dev/web/app/mods/e_down.php
===================================================================
--- /branches/rsr.v5.1.dev/web/app/mods/e_down.php	(revision 1)
+++ /branches/rsr.v5.1.dev/web/app/mods/e_down.php	(revision 1)
@@ -0,0 +1,13 @@
+<?php
+
+  function e_down($env)
+  { if(($url = $env->data->inc_download_compteur($_GET[$env->param("download")])) !== false)
+    { if($force_download = $env->config("force_download"))
+      { $url = preg_replace($force_download["replace_from"], $force_download["replace_to"], $url);
+      }
+      header("Location: ".$url);
+    }
+    else echo "Erreur lors de l'acc&egrave;s au download";
+  }
+
+?>
Index: /branches/rsr.v5.1.dev/web/app/mods/e_downalbum.php
===================================================================
--- /branches/rsr.v5.1.dev/web/app/mods/e_downalbum.php	(revision 1)
+++ /branches/rsr.v5.1.dev/web/app/mods/e_downalbum.php	(revision 1)
@@ -0,0 +1,10 @@
+<?php
+
+  function e_downalbum($env)
+  { if(($url = $env->data->inc_album_compteur($_GET[$env->param("album")])) !== false)
+    { header("Location: ".$url);
+    }
+    else echo "Erreur lors de l'acc&egrave;s &agrave; l'album";
+  }
+
+?>
Index: /branches/rsr.v5.1.dev/web/app/mods/e_edito.php
===================================================================
--- /branches/rsr.v5.1.dev/web/app/mods/e_edito.php	(revision 1)
+++ /branches/rsr.v5.1.dev/web/app/mods/e_edito.php	(revision 1)
@@ -0,0 +1,18 @@
+<?php
+
+  function e_edito($env)
+  { if(($env->out["edito"] = $env->data->edito()) !== false)
+    { $path = array("root", "news");
+      $depth = 1;
+      if(($env->out["categories"] = $env->data->all_news_categories()) !== false)
+      { if(($env->out["news"] = $env->data->news($path, 0, $depth, true, 5)) !== false)
+        { 
+        }
+        else $env->erreur .= "<br>Impossible de lire la liste des news";
+      }
+      else $env->erreur .= "<br>Impossible de lire la liste des categories de news";
+    }
+    else $env->erreur = "Impossible de lire l'&eacute;dito";
+  }
+
+?>
Index: /branches/rsr.v5.1.dev/web/app/mods/e_forum.php
===================================================================
--- /branches/rsr.v5.1.dev/web/app/mods/e_forum.php	(revision 1)
+++ /branches/rsr.v5.1.dev/web/app/mods/e_forum.php	(revision 1)
@@ -0,0 +1,26 @@
+<?php
+
+  function e_forum($env)
+  { global $tpl_main;
+    $env->out["forum"] = array();
+    $env->out["forum"]["head"] = "";
+    $env->out["forum"]["body"] = "";
+    if
+    ( ($head_start = stripos($tpl_main, "<head")) !== false &&
+      ($head_start = stripos($tpl_main, ">", $head_start)) !== false &&
+      ($head_end = stripos($tpl_main, "</head", $head_start)) !== false
+    )
+    { $head_start += 1;
+      $env->out["forum"]["head"] .= substr($tpl_main, $head_start, $head_end - $head_start);
+    }
+    if
+    ( ($body_start = stripos($tpl_main, "<body")) !== false &&
+      ($body_start = stripos($tpl_main, ">", $body_start)) !== false &&
+      ($body_end = stripos($tpl_main, "</body", $body_start)) !== false
+    )
+    { $body_start += 1;
+      $env->out["forum"]["body"] .= substr($tpl_main, $body_start, $body_end - $body_start);
+    }
+  }
+
+?>
Index: /branches/rsr.v5.1.dev/web/app/mods/e_links.php
===================================================================
--- /branches/rsr.v5.1.dev/web/app/mods/e_links.php	(revision 1)
+++ /branches/rsr.v5.1.dev/web/app/mods/e_links.php	(revision 1)
@@ -0,0 +1,35 @@
+<?php
+
+  function e_links($env)
+  { $env->path = array("root", "links");
+    $env->out["ariane"] = array();
+    if($_GET[$env->param("path")])
+    { $v_path = explode("/", $_GET[$env->param("path")]);
+      foreach($v_path as $_path) if($_path)
+      { $env->path[] = (int)$_path;
+        $env->out["ariane"][$_path] = $env->data->links_categorie($_path);
+      }
+    }
+    if(($env->out["current_categorie"] = $env->data->id_categorie($env->path)) !== false)
+    { $env->a = "links";
+      $function = "a_".$env->a;
+      if(function_exists($function)) $function($env);
+    }
+    else $env->erreur = "Impossible de lire le lien courant";
+  }
+
+  # ------------------------------------------------------------------------------
+  #                                                                        actions
+  #
+
+  function a_links($env)
+  { if(($env->out["link"] = $env->data->links_categorie($env->out["current_categorie"])) !== false)
+    { if(($env->out["links_categories"] = $env->data->links_categories($env->path)) !== false)
+      {
+      }
+      else $env->erreur = "Impossible de lire les liens";
+    }
+    else $env->erreur = "Impossible de lire le lien courant";
+  }
+
+?>
Index: /branches/rsr.v5.1.dev/web/app/mods/e_m3u.php
===================================================================
--- /branches/rsr.v5.1.dev/web/app/mods/e_m3u.php	(revision 1)
+++ /branches/rsr.v5.1.dev/web/app/mods/e_m3u.php	(revision 1)
@@ -0,0 +1,17 @@
+<?php
+
+  function e_m3u($env)
+  { if(($url = $env->data->inc_download_compteur($_GET[$env->param("download")])) !== false)
+    { $playlist =
+       "#EXTM3U\n"
+      ."#EXTINF:-1,playlist.mp3\n"
+      .$url."\n";
+      header("Content-type: audio/x-mpegurl");
+      header('Content-Disposition: inline; filename=playlist.m3u');
+      header("Content-Length: ".strlen($playlist));
+      echo $playlist;
+    }
+    else echo "Erreur lors de l'acc&egrave;s au download";
+  }
+
+?>
Index: /branches/rsr.v5.1.dev/web/app/mods/e_news.php
===================================================================
--- /branches/rsr.v5.1.dev/web/app/mods/e_news.php	(revision 1)
+++ /branches/rsr.v5.1.dev/web/app/mods/e_news.php	(revision 1)
@@ -0,0 +1,19 @@
+<?php
+
+  function e_news($env)
+  { $path = array("root", "news");
+    $depth = 1;
+    if(isset($_GET[$env->param("categorie")]))
+    { if(strlen($_GET[$env->param("categorie")]) > 0) $path[] = (int)$_GET[$env->param("categorie")];
+      $depth = 0;
+    }
+    if(($env->out["categories"] = $env->data->all_news_categories()) !== false)
+    { if(($env->out["news"] = $env->data->news($path, $env->start, $depth, true)) !== false)
+      {
+      }
+      else $env->erreur .= "<br>Impossible de lire les news";
+    }
+    else $env->erreur .= "<br>Impossible de lire la liste des categories de news";
+  }
+
+?>
Index: /branches/rsr.v5.1.dev/web/app/mods/e_page.php
===================================================================
--- /branches/rsr.v5.1.dev/web/app/mods/e_page.php	(revision 1)
+++ /branches/rsr.v5.1.dev/web/app/mods/e_page.php	(revision 1)
@@ -0,0 +1,10 @@
+<?php
+
+  function e_page($env)
+  { if(($env->out["page"] = $env->data->contenu($_GET[$env->param("id")])) !== false)
+    {
+    }
+    else $env->erreur .= "<br>Impossible de lire la page";
+  }
+
+?>
Index: /branches/rsr.v5.1.dev/web/app/mods/e_playlist.php
===================================================================
--- /branches/rsr.v5.1.dev/web/app/mods/e_playlist.php	(revision 1)
+++ /branches/rsr.v5.1.dev/web/app/mods/e_playlist.php	(revision 1)
@@ -0,0 +1,30 @@
+<?php
+
+  function e_playlist($env)
+  { if($_GET[$env->param("action")])
+    { $env->a = $_GET[$env->param("action")];
+      $function = "a_".$env->a;
+      if(function_exists($function))
+      { if(($env->out["licences"] = $env->data->licences()) !== false)
+        { $function($env);
+        }
+        else $env->erreur = "Impossible de lire la liste des licences";
+      }
+    }
+  }
+
+  function a_last_downloads($env)
+  { if(($env->out["downloads"] = $env->data->pl_last_downloads(10)) !== false)
+    {
+    }
+    else $env->erreur = "Impossible de lire la liste des downloads.";
+  }
+
+  function a_rand_downloads($env)
+  { if(($env->out["downloads"] = $env->data->pl_rand_downloads(10)) !== false)
+    {
+    }
+    else $env->erreur = "Impossible de lire la liste des downloads.";
+  }
+
+?>
Index: /branches/rsr.v5.1.dev/web/app/mods/e_popup_info.php
===================================================================
--- /branches/rsr.v5.1.dev/web/app/mods/e_popup_info.php	(revision 1)
+++ /branches/rsr.v5.1.dev/web/app/mods/e_popup_info.php	(revision 1)
@@ -0,0 +1,7 @@
+<?php
+
+  function e_popup_info($env)
+  { $env->a = $_GET[$env->param("action")] ? $_GET[$env->param("action")] : "";
+  }
+
+?>
Index: /branches/rsr.v5.1.dev/web/app/mods/e_rechercher.php
===================================================================
--- /branches/rsr.v5.1.dev/web/app/mods/e_rechercher.php	(revision 1)
+++ /branches/rsr.v5.1.dev/web/app/mods/e_rechercher.php	(revision 1)
@@ -0,0 +1,15 @@
+<?php
+
+  function e_rechercher($env)
+  { if($_POST["match"])
+    { if(($env->out["licences"] = $env->data->licences()) !== false)
+      { if(($env->out["results"] = $env->data->search($_POST["match"])) !== false) 
+        {
+        }
+        else $env->erreur = "Impossible de faire la recherche";
+      }
+      else $env->erreur = "Impossible de lire la liste des licences";
+    }
+  }
+
+?>
Index: /branches/rsr.v5.1.dev/web/app/mods/e_set_artiste_albums.php
===================================================================
--- /branches/rsr.v5.1.dev/web/app/mods/e_set_artiste_albums.php	(revision 1)
+++ /branches/rsr.v5.1.dev/web/app/mods/e_set_artiste_albums.php	(revision 1)
@@ -0,0 +1,217 @@
+<?php
+
+  function e_set_artiste_albums($env)
+  { $env->out["edit_ok"] = false;
+    if(($env->out["artiste"] = $env->data->artiste($_GET[$env->param("artiste")])) !== false)
+    { if
+      (    $env->pun_user["is_super_admin"]
+        || $env->pun_user["id"] === $env->out["artiste"]["pun_user"]
+        || $env->data->is_artiste_admin($_GET[$env->param("artiste")], $env->pun_user["id"])
+      )
+      { $env->out["edit_ok"] = true;
+        $env->a = $_GET[$env->param("action")] ? $_GET[$env->param("action")] : "albums";
+        $function = "a_".$env->a;
+        if(function_exists($function)) $function($env);
+      }
+      else $env->erreur = "Vous n'&ecirc;tes pas identifi&eacute; comme administrateur de cet artiste.";
+    }
+    else $env->erreur = "Impossible de lire les infos de l'artiste";
+  }
+
+  # ------------------------------------------------------------------------------
+  #                                                                        actions
+  #
+
+  function a_albums($env)
+  { if(($env->out["albums"] = $env->data->artiste_albums($_GET[$env->param("artiste")])) !== false)
+    {
+    }
+    else $env->erreur = "Impossible de lire les albums de l'artiste";
+  }
+
+  function a_set_albums($env)
+  { $ordre = array();
+    $actif = array();
+    foreach($_POST as $key => $value)
+    { if(strpos($key, "ordre_") === 0 && strlen($value) > 0)
+      { $ordre[substr($key, 6)] = $value;
+      }
+      if(strpos($key, "actif_") === 0 && strlen($value) > 0)
+      { $actif[substr($key, 6)] = $value;
+      }
+    }
+    if($env->data->set_artiste_albums($_GET[$env->param("artiste")], $ordre, $actif) !== false)
+    { _redirect
+      ( $env,
+        $env->url(array("e" => "set_artiste_albums", "artiste" => $_GET[$env->param("artiste")])),
+        "Les albums ont &eacute;t&eacute; mis &agrave; jour"
+      );
+    }
+    else $env->erreur = "Impossible de mettre &agrave; jour les albums";
+  }
+
+  function a_add_album($env)
+  { if($_POST)
+    { $image = false;
+      if($_FILES["image"] && $_FILES["image"]["error"] != UPLOAD_ERR_NO_FILE)
+      { switch($_FILES["image"]["error"])
+        { case UPLOAD_ERR_OK : break;
+          default : $env->erreur = "Impossible d'uploader l'image.";
+        }
+        if(!$env->erreur)
+        { $v_name = explode(".", $_FILES["image"]["name"]);
+          $ext = $v_name[count($v_name) - 1];
+          if
+          ( strcasecmp($ext, "png") == 0 ||
+            strcasecmp($ext, "gif") == 0 ||
+            strcasecmp($ext, "jpg") == 0 ||
+            strcasecmp($ext, "jpeg") == 0
+          )
+          { $dest = $env->path("uploads")."artistes/".$env->out["artiste"]["id"];
+            if(file_exists($dest))
+            { if(!is_dir($dest)) $env->erreur = "le dossier d'upload est un fichier. Impossible d'y uploader l'image";
+            }
+            else
+            { @mkdir($dest);
+              clearstatcache();
+              if(!file_exists($dest) && !is_dir($dest)) $env->erreur = "Impossible de creer le dossier d'upload";
+            }
+            if(!$env->erreur)
+            { if
+              ( @move_uploaded_file
+                ( $_FILES["image"]["tmp_name"],
+                  $dest."/".$_FILES["image"]["name"]
+                ) !== false
+              ) $image = $dest."/".$_FILES["image"]["name"];
+              else $env->erreur = "Impossible de copier l'image upload&eacute;e";
+            }
+          }
+          else $env->message = "Le fichier image doit &ecirc;tre au format png, gif ou jpg";
+        }
+      }
+      if(!$env->message && !$env->erreur)
+      { if
+        ( $env->data->add_artiste_album
+          ( $env->out["artiste"]["id"],
+            $_POST["titre"],
+            $image !== false ? $image : "",
+            $_POST["description"],
+            $_POST["url"],
+            $_POST["format"],
+            $_POST["taille"],
+            $_POST["annee_date_creation"]."-".$_POST["mois_date_creation"]."-".$_POST["jour_date_creation"]
+          )
+        )
+        { _redirect
+          ( $env,
+            $env->url(array("e" => "set_artiste_albums", "artiste" => $env->out["artiste"]["id"])),
+            "L'album a &eacute;t&eacute; ajout&eacute;"
+          );
+        }
+        else $env->erreur = "Impossible d'ajouter l'album";
+      }
+    }
+    else
+    { if(($env->out["formats"] = $env->data->formats()) !== false)
+      {
+      }
+      else $env->erreur = "Impossible de lire la liste des formats";
+    }
+  }
+
+  function a_set_album($env)
+  { if(($env->out["album"] = $env->data->artiste_album($_GET[$env->param("album")])) !== false)
+    { if($_POST)
+      { $image = false;
+        if($_POST["del_image"] && $env->out["album"]["image"] && !is_dir($env->out["album"]["image"]))
+        { @unlink($env->out["album"]["image"]);
+          clearstatcache();
+          if(file_exists($env->out["album"]["image"])) $env->erreur = "Impossible d'effacer l'image";
+          else $image = null;
+        }
+        if(!$env->erreur && $_FILES["image"] && $_FILES["image"]["error"] != UPLOAD_ERR_NO_FILE)
+        { switch($_FILES["image"]["error"])
+          { case UPLOAD_ERR_OK : break;
+            default : $env->erreur = "Impossible d'uploader l'image.";
+          }
+          if(!$env->erreur)
+          { $v_name = explode(".", $_FILES["image"]["name"]);
+            $ext = $v_name[count($v_name) - 1];
+            if
+            ( strcasecmp($ext, "png") == 0 ||
+              strcasecmp($ext, "gif") == 0 ||
+              strcasecmp($ext, "jpg") == 0 ||
+              strcasecmp($ext, "jpeg") == 0
+            )
+            { $dest = $env->path("uploads")."artistes/".$env->out["artiste"]["id"];
+              if(file_exists($dest))
+              { if(!is_dir($dest)) $env->erreur = "le dossier d'upload est un fichier. Impossible d'y uploader l'image";
+              }
+              else
+              { @mkdir($dest);
+                clearstatcache();
+                if(!file_exists($dest) && !is_dir($dest)) $env->erreur = "Impossible de creer le dossier d'upload";
+              }
+              if(!$env->erreur)
+              { if($env->out["album"]["image"] && file_exists($env->out["album"]["image"]))
+                { @unlink($env->out["album"]["image"]);
+                  clearstatcache();
+                  if(file_exists($env->out["artiste"]["image"])) $env->erreur = "Impossible d'effacer l'ancienne image";
+                }
+                if(!$env->erreur)
+                { if
+                  ( @move_uploaded_file
+                    ( $_FILES["image"]["tmp_name"],
+                      $dest."/".$_FILES["image"]["name"]
+                    ) !== false
+                  ) $image = $dest."/".$_FILES["image"]["name"];
+                  else $env->erreur = "Impossible de copier l'image uploadee";
+                }
+              }
+            }
+            else $env->message = "Le fichier image doit &ecirc;tre au format png, gif ou jpg";
+          }
+        }
+        if(!$env->message && !$env->erreur)
+        { if
+          ( $env->data->set_artiste_album
+            ( $_GET[$env->param("album")],
+              $_POST["titre"],
+              $image !== false ? $image : $env->out["album"]["image"],
+              $_POST["description"],
+              $_POST["url"],
+              $_POST["format"],
+              $_POST["taille"],
+              $_POST["annee_date_creation"]."-".$_POST["mois_date_creation"]."-".$_POST["jour_date_creation"]
+            )
+          )
+          { _redirect
+            ( $env,
+              $env->url(array("e" => "set_artiste_albums", "artiste" => $env->out["artiste"]["id"])),
+              "L'album a &eacute;t&eacute; modifi&eacute;"
+            );
+          }
+          else $env->erreur = "Impossible d'enregitrer les modifications";
+        }
+      }
+      else
+      { if(($env->out["formats"] = $env->data->formats()) !== false)
+        {
+        }
+        else $env->erreur = "Impossible de lire la liste des formats";
+      }
+    }
+  }
+
+  function a_del_album($env)
+  { if($env->data->del_artiste_album($_GET[$env->param("album")]))
+    { _redirect
+      ( $env,
+        $env->url(array("e" => "set_artiste_albums", "artiste" => $env->out["artiste"]["id"])),
+        "L'album a &eacute;t&eacute; supprim&eacute;"
+      );
+    }
+    else $env->erreur = "Impossible de supprimer l'album";
+  }
+
+?>
